## GOutputStream

GOutputStream — Base class for implementing streaming output

## Functions

gssize | g_output_stream_write ()
gboolean | g_output_stream_write_all ()
void | g_output_stream_write_all_async ()
gboolean | g_output_stream_write_all_finish ()
gssize | g_output_stream_splice ()
gboolean | g_output_stream_flush ()
gboolean | g_output_stream_close ()
void | g_output_stream_write_async ()
gssize | g_output_stream_write_finish ()
void | g_output_stream_splice_async ()
gssize | g_output_stream_splice_finish ()
void | g_output_stream_flush_async ()
gboolean | g_output_stream_flush_finish ()
void | g_output_stream_close_async ()
gboolean | g_output_stream_close_finish ()
gboolean | g_output_stream_is_closing ()
gboolean | g_output_stream_is_closed ()
gboolean | g_output_stream_has_pending ()
gboolean | g_output_stream_set_pending ()
void | g_output_stream_clear_pending ()
gssize | g_output_stream_write_bytes ()
void | g_output_stream_write_bytes_async ()
gssize | g_output_stream_write_bytes_finish ()
gboolean | g_output_stream_printf ()
gboolean | g_output_stream_vprintf ()

## Types and Values

enum | GOutputStreamSpliceFlags
| GOutputStream

## Object Hierarchy

        GObject
        ╰── GOutputStream
            ├── GFilterOutputStream
            ├── GFileOutputStream
            ├── GMemoryOutputStream
            ╰── GUnixOutputStream

## Known Derived Interfaces

GOutputStream is required by GPollableOutputStream.

## Includes

    #include <gio/gio.h>

## Description

GOutputStream has functions to write to a stream (`g_output_stream_write()`), to close a stream (`g_output_stream_close()`) and to flush pending writes (`g_output_stream_flush()`).

To copy the content of an input stream to an output stream without manually handling the reads and writes, use `g_output_stream_splice()`.

See the documentation for GIOStream for details of thread safety of streaming APIs.

All of these functions have async variants too.

## Functions

### g_output_stream_write ()

    gssize
    g_output_stream_write (GOutputStream *stream,
                           const void *buffer,
                           gsize count,
                           GCancellable *cancellable,
                           GError **error);

Tries to write `count` bytes from `buffer` into the stream. Will block during the operation.

If count is 0, returns 0 and does nothing. A value of `count` larger than `G_MAXSSIZE` will cause a `G_IO_ERROR_INVALID_ARGUMENT` error.

On success, the number of bytes written to the stream is returned. It is not an error if this is not the same as the requested size, as it can happen e.g. on a partial I/O error, or if there is not enough storage in the stream. All writes block until at least one byte is written or an error occurs; 0 is never returned (unless `count` is 0).

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

On error -1 is returned and `error` is set accordingly.

Virtual: write_fn

#### Parameters

stream | a GOutputStream. |
buffer | the buffer containing the data to write. | [array length=count][element-type guint8]
count | the number of bytes to write |
cancellable | optional cancellable object. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

Number of bytes written, or -1 on error

### g_output_stream_write_all ()

    gboolean
    g_output_stream_write_all (GOutputStream *stream,
                               const void *buffer,
                               gsize count,
                               gsize *bytes_written,
                               GCancellable *cancellable,
                               GError **error);

Tries to write `count` bytes from `buffer` into the stream. Will block during the operation.

This function is similar to `g_output_stream_write()`, except it tries to write as many bytes as requested, only stopping on an error.

On a successful write of `count` bytes, `TRUE` is returned, and `bytes_written` is set to `count` .

If there is an error during the operation `FALSE` is returned and `error` is set to indicate the error status.

As a special exception to the normal conventions for functions that use GError, if this function returns `FALSE` (and sets `error` ) then `bytes_written` will be set to the number of bytes that were successfully written before the error was encountered. This functionality is only available from C. If you need it from another language then you must write your own loop around `g_output_stream_write()`.

#### Parameters

stream | a GOutputStream. |
buffer | the buffer containing the data to write. | [array length=count][element-type guint8]
count | the number of bytes to write |
bytes_written | location to store the number of bytes that was written to the stream. | [out][optional]
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

`TRUE` on success, `FALSE` if there was an error

### g_output_stream_write_all_async ()

    void
    g_output_stream_write_all_async (GOutputStream *stream,
                                     const void *buffer,
                                     gsize count,
                                     int io_priority,
                                     GCancellable *cancellable,
                                     GAsyncReadyCallback callback,
                                     gpointer user_data);

Request an asynchronous write of `count` bytes from `buffer` into the stream. When the operation is finished `callback` will be called. You can then call `g_output_stream_write_all_finish()` to get the result of the operation.

This is the asynchronous version of `g_output_stream_write_all()`.

Call `g_output_stream_write_all_finish()` to collect the result.

Any outstanding I/O request with higher priority (lower numerical value) will be executed before an outstanding request with lower priority. Default priority is `G_PRIORITY_DEFAULT`.

Note that no copy of `buffer` will be made, so it must stay valid until `callback` is called.

#### Parameters

stream | A GOutputStream |
buffer | the buffer containing the data to write. | [array length=count][element-type guint8]
count | the number of bytes to write |
io_priority | the io priority of the request |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | callback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

Since: 2.44

### g_output_stream_write_all_finish ()

    gboolean
    g_output_stream_write_all_finish (GOutputStream *stream,
                                      GAsyncResult *result,
                                      gsize *bytes_written,
                                      GError **error);

Finishes an asynchronous stream write operation started with `g_output_stream_write_all_async()`.

As a special exception to the normal conventions for functions that use GError, if this function returns `FALSE` (and sets `error` ) then `bytes_written` will be set to the number of bytes that were successfully written before the error was encountered. This functionality is only available from C. If you need it from another language then you must write your own loop around `g_output_stream_write_async()`.

#### Parameters

stream | a GOutputStream |
result | a GAsyncResult |
bytes_written | location to store the number of bytes that was written to the stream. | [out][optional]
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` if there was an error

Since: 2.44

### g_output_stream_splice ()

    gssize
    g_output_stream_splice (GOutputStream *stream,
                            GInputStream *source,
                            GOutputStreamSpliceFlags flags,
                            GCancellable *cancellable,
                            GError **error);

Splices an input stream into an output stream.

#### Parameters

stream | a GOutputStream. |
source | a GInputStream. |
flags | a set of GOutputStreamSpliceFlags. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

a gssize containing the size of the data spliced, or -1 if an error occurred. Note that if the number of bytes spliced is greater than `G_MAXSSIZE`, then that will be returned, and there is no way to determine the actual number of bytes spliced.

### g_output_stream_flush ()

    gboolean
    g_output_stream_flush (GOutputStream *stream,
                           GCancellable *cancellable,
                           GError **error);

Forces a write of all user-space buffered data for the given `stream` . Will block during the operation. Closing the stream will implicitly cause a flush.

This function is optional for inherited classes.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

#### Parameters

stream | a GOutputStream. |
cancellable | optional cancellable object. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

`TRUE` on success, `FALSE` on error

### g_output_stream_close ()

    gboolean
    g_output_stream_close (GOutputStream *stream,
                           GCancellable *cancellable,
                           GError **error);

Closes the stream, releasing resources related to it.

Once the stream is closed, all other operations will return `G_IO_ERROR_CLOSED`. Closing a stream multiple times will not return an error.

Closing a stream will automatically flush any outstanding buffers in the stream.

Streams will be automatically closed when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

Some streams might keep the backing store of the stream (e.g. a file descriptor) open after the stream is closed. See the documentation for the individual stream for details.

On failure the first error that happened will be reported, but the close operation will finish as much as possible. A stream that failed to close will still return `G_IO_ERROR_CLOSED` for all operations. Still, it is important to check and report the error to the user, otherwise there might be a loss of data as all data might not be written.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. Cancelling a close will still leave the stream closed, but there some streams can use a faster close that doesn't block to e.g. check errors. On cancellation (as with any error) there is no guarantee that all written data will reach the target.

#### Parameters

stream | A GOutputStream. |
cancellable | optional cancellable object. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

`TRUE` on success, `FALSE` on failure

### g_output_stream_write_async ()

    void
    g_output_stream_write_async (GOutputStream *stream,
                                 const void *buffer,
                                 gsize count,
                                 int io_priority,
                                 GCancellable *cancellable,
                                 GAsyncReadyCallback callback,
                                 gpointer user_data);

Request an asynchronous write of `count` bytes from `buffer` into the stream. When the operation is finished `callback` will be called. You can then call `g_output_stream_write_finish()` to get the result of the operation.

During an async request no other sync and async calls are allowed, and will result in `G_IO_ERROR_PENDING` errors.

A value of `count` larger than `G_MAXSSIZE` will cause a `G_IO_ERROR_INVALID_ARGUMENT` error.

On success, the number of bytes written will be passed to the `callback` . It is not an error if this is not the same as the requested size, as it can happen e.g. on a partial I/O error, but generally we try to write as many bytes as requested.

You are guaranteed that this method will never fail with `G_IO_ERROR_WOULD_BLOCK` - if `stream` can't accept more data, the method will just wait until this changes.

Any outstanding I/O request with higher priority (lower numerical value) will be executed before an outstanding request with lower priority. Default priority is `G_PRIORITY_DEFAULT`.

The asynchronous methods have a default fallback that uses threads to implement asynchronicity, so they are optional for inheriting classes. However, if you override one you must override all.

For the synchronous, blocking version of this function, see `g_output_stream_write()`.

Note that no copy of `buffer` will be made, so it must stay valid until `callback` is called. See `g_output_stream_write_bytes_async()` for a GBytes version that will automatically hold a reference to the contents (without copying) for the duration of the call.

#### Parameters

stream | A GOutputStream. |
buffer | the buffer containing the data to write. | [array length=count][element-type guint8]
count | the number of bytes to write |
io_priority | the io priority of the request. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | callback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_output_stream_write_finish ()

    gssize
    g_output_stream_write_finish (GOutputStream *stream,
                                  GAsyncResult *result,
                                  GError **error);

Finishes a stream write operation.

#### Parameters

stream | a GOutputStream. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

a gssize containing the number of bytes written to the stream.

### g_output_stream_splice_async ()

    void
    g_output_stream_splice_async (GOutputStream *stream,
                                  GInputStream *source,
                                  GOutputStreamSpliceFlags flags,
                                  int io_priority,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Splices a stream asynchronously. When the operation is finished `callback` will be called. You can then call `g_output_stream_splice_finish()` to get the result of the operation.

For the synchronous, blocking version of this function, see `g_output_stream_splice()`.

#### Parameters

stream | a GOutputStream. |
source | a GInputStream. |
flags | a set of GOutputStreamSpliceFlags. |
io_priority | the io priority of the request. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]

### g_output_stream_splice_finish ()

    gssize
    g_output_stream_splice_finish (GOutputStream *stream,
                                   GAsyncResult *result,
                                   GError **error);

Finishes an asynchronous stream splice operation.

#### Parameters

stream | a GOutputStream. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

a gssize of the number of bytes spliced. Note that if the number of bytes spliced is greater than `G_MAXSSIZE`, then that will be returned, and there is no way to determine the actual number of bytes spliced.

### g_output_stream_flush_async ()

    void
    g_output_stream_flush_async (GOutputStream *stream,
                                 int io_priority,
                                 GCancellable *cancellable,
                                 GAsyncReadyCallback callback,
                                 gpointer user_data);

Forces an asynchronous write of all user-space buffered data for the given `stream` . For behaviour details see `g_output_stream_flush()`.

When the operation is finished `callback` will be called. You can then call `g_output_stream_flush_finish()` to get the result of the operation.

#### Parameters

stream | a GOutputStream. |
io_priority | the io priority of the request. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_output_stream_flush_finish ()

    gboolean
    g_output_stream_flush_finish (GOutputStream *stream,
                                  GAsyncResult *result,
                                  GError **error);

Finishes flushing an output stream.

#### Parameters

stream | a GOutputStream. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

`TRUE` if flush operation succeeded, `FALSE` otherwise.

### g_output_stream_close_async ()

    void
    g_output_stream_close_async (GOutputStream *stream,
                                 int io_priority,
                                 GCancellable *cancellable,
                                 GAsyncReadyCallback callback,
                                 gpointer user_data);

Requests an asynchronous close of the stream, releasing resources related to it. When the operation is finished `callback` will be called. You can then call `g_output_stream_close_finish()` to get the result of the operation.

For behaviour details see `g_output_stream_close()`.

The asynchronous methods have a default fallback that uses threads to implement asynchronicity, so they are optional for inheriting classes. However, if you override one you must override all.

#### Parameters

stream | A GOutputStream. |
io_priority | the io priority of the request. |
cancellable | optional cancellable object. | [nullable]
callback | callback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_output_stream_close_finish ()

    gboolean
    g_output_stream_close_finish (GOutputStream *stream,
                                  GAsyncResult *result,
                                  GError **error);

Closes an output stream.

#### Parameters

stream | a GOutputStream. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

`TRUE` if stream was successfully closed, `FALSE` otherwise.

### g_output_stream_is_closing ()

    gboolean
    g_output_stream_is_closing (GOutputStream *stream);

Checks if an output stream is being closed. This can be used inside e.g. a flush implementation to see if the flush (or other i/o operation) is called from within the closing operation.

#### Parameters

stream | a GOutputStream. |

#### Returns

`TRUE` if `stream` is being closed. `FALSE` otherwise.

Since: 2.24

### g_output_stream_is_closed ()

    gboolean
    g_output_stream_is_closed (GOutputStream *stream);

Checks if an output stream has already been closed.

#### Parameters

stream | a GOutputStream. |

#### Returns

`TRUE` if `stream` is closed. `FALSE` otherwise.

### g_output_stream_has_pending ()

    gboolean
    g_output_stream_has_pending (GOutputStream *stream);

Checks if an output stream has pending actions.

#### Parameters

stream | a GOutputStream. |

#### Returns

`TRUE` if `stream` has pending actions.

### g_output_stream_set_pending ()

    gboolean
    g_output_stream_set_pending (GOutputStream *stream,
                                 GError **error);

Sets `stream` to have actions pending. If the pending flag is already set or `stream` is closed, it will return `FALSE` and set `error` .

#### Parameters

stream | a GOutputStream. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

`TRUE` if pending was previously unset and is now set.

### g_output_stream_clear_pending ()

    void
    g_output_stream_clear_pending (GOutputStream *stream);

Clears the pending flag on `stream` .

#### Parameters

stream | output stream |

### g_output_stream_write_bytes ()

    gssize
    g_output_stream_write_bytes (GOutputStream *stream,
                                 GBytes *bytes,
                                 GCancellable *cancellable,
                                 GError **error);

A wrapper function for `g_output_stream_write()` which takes a GBytes as input. This can be more convenient for use by language bindings or in other cases where the refcounted nature of GBytes is helpful over a bare pointer interface.

However, note that this function may still perform partial writes, just like `g_output_stream_write()`. If that occurs, to continue writing, you will need to create a new GBytes containing just the remaining bytes, using `g_bytes_new_from_bytes()`. Passing the same GBytes instance multiple times potentially can result in duplicated data in the output stream.

#### Parameters

stream | a GOutputStream. |
bytes | the GBytes to write |
cancellable | optional cancellable object. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |

#### Returns

Number of bytes written, or -1 on error

### g_output_stream_write_bytes_async ()

    void
    g_output_stream_write_bytes_async (GOutputStream *stream,
                                       GBytes *bytes,
                                       int io_priority,
                                       GCancellable *cancellable,
                                       GAsyncReadyCallback callback,
                                       gpointer user_data);

This function is similar to `g_output_stream_write_async()`, but takes a GBytes as input. Due to the refcounted nature of GBytes, this allows the stream to avoid taking a copy of the data.

However, note that this function may still perform partial writes, just like `g_output_stream_write_async()`. If that occurs, to continue writing, you will need to create a new GBytes containing just the remaining bytes, using `g_bytes_new_from_bytes()`. Passing the same GBytes instance multiple times potentially can result in duplicated data in the output stream.

For the synchronous, blocking version of this function, see `g_output_stream_write_bytes()`.

#### Parameters

stream | A GOutputStream. |
bytes | The bytes to write |
io_priority | the io priority of the request. |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | callback to call when the request is satisfied. | [scope async]
user_data | the data to pass to callback function. | [closure]

### g_output_stream_write_bytes_finish ()

    gssize
    g_output_stream_write_bytes_finish (GOutputStream *stream,
                                        GAsyncResult *result,
                                        GError **error);

Finishes a stream write-from-GBytes operation.

#### Parameters

stream | a GOutputStream. |
result | a GAsyncResult. |
error | a GError location to store the error occurring, or `NULL` to ignore. |

#### Returns

a gssize containing the number of bytes written to the stream.

### g_output_stream_printf ()

    gboolean
    g_output_stream_printf (GOutputStream *stream,
                            gsize *bytes_written,
                            GCancellable *cancellable,
                            GError **error,
                            const gchar *format,
                            ...);

This is a utility function around `g_output_stream_write_all()`. It uses `g_strdup_vprintf()` to turn `format` and @... into a string that is then written to `stream` .

See the documentation of `g_output_stream_write_all()` about the behavior of the actual write operation.

Note that partial writes cannot be properly checked with this function due to the variable length of the written string, if you need precise control over partial write failures, you need to create you own `printf()`-like wrapper around `g_output_stream_write()` or `g_output_stream_write_all()`.

#### Parameters

stream | a GOutputStream. |
bytes_written | location to store the number of bytes that was written to the stream. | [out][optional]
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |
format | the format string. See the `printf()` documentation |
... | the parameters to insert into the format string |

#### Returns

`TRUE` on success, `FALSE` if there was an error

Since: 2.40

### g_output_stream_vprintf ()

    gboolean
    g_output_stream_vprintf (GOutputStream *stream,
                             gsize *bytes_written,
                             GCancellable *cancellable,
                             GError **error,
                             const gchar *format,
                             va_list args);

This is a utility function around `g_output_stream_write_all()`. It uses `g_strdup_vprintf()` to turn `format` and `args` into a string that is then written to `stream` .

See the documentation of `g_output_stream_write_all()` about the behavior of the actual write operation.

Note that partial writes cannot be properly checked with this function due to the variable length of the written string, if you need precise control over partial write failures, you need to create you own `printf()`-like wrapper around `g_output_stream_write()` or `g_output_stream_write_all()`.

#### Parameters

stream | a GOutputStream. |
bytes_written | location to store the number of bytes that was written to the stream. | [out][optional]
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
error | location to store the error occurring, or `NULL` to ignore |
format | the format string. See the `printf()` documentation |
args | the parameters to insert into the format string |

#### Returns

`TRUE` on success, `FALSE` if there was an error

Since: 2.40

## Types and Values

### enum GOutputStreamSpliceFlags

GOutputStreamSpliceFlags determine how streams should be spliced.

#### Members

G_OUTPUT_STREAM_SPLICE_NONE | Do not close either stream. |
G_OUTPUT_STREAM_SPLICE_CLOSE_SOURCE | Close the source stream after the splice. |
G_OUTPUT_STREAM_SPLICE_CLOSE_TARGET | Close the target stream after the splice. |

### GOutputStream

    typedef struct _GOutputStream GOutputStream;

Base class for writing output.

All classes derived from GOutputStream should implement synchronous writing, splicing, flushing and closing streams, but may implement asynchronous versions.